package com.sobot.demo;

import android.content.IntentFilter;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentPagerAdapter;
import androidx.viewpager.widget.ViewPager;

import com.sobot.chat.utils.LogUtils;
import com.sobot.chat.utils.ZhiChiConstant;
import com.sobot.demo.tab.SobotPagerSlidingTab;
import com.sobot.demo.tab.SobotViewPagerAdapter;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Administrator on 2017/11/20.
 */

public class SobotDemoNewActivity extends AppCompatActivity {

    private SobotUnReadMsgReceiver unReadMsgReceiver;//获取未读消息数的广播接收者
    private SobotPagerSlidingTab mTab;
    private List<String> tabs = new ArrayList<>();//
    private List<Fragment> mFragments;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sobot_demo_new_activity);
        if (getSupportActionBar() != null){
            getSupportActionBar().hide();
        }
        LogUtils.isDebug = true;
        mFragments = new ArrayList<>();
        ViewPager viewPager = (ViewPager) findViewById(R.id.viewPager);
        tabs.add("产品介绍");
        tabs.add("更多");
        mFragments.add(new SobotDemoWelcomeFragment());
        mFragments.add(new SobotDemoNewSettingFragment());
        SobotViewPagerAdapter pagerAdapter = new SobotViewPagerAdapter(this, getSupportFragmentManager(), tabs.toArray(new String[tabs.size()]), mFragments);
        viewPager.setAdapter(pagerAdapter);
        viewPager.setOffscreenPageLimit(mFragments.size());
        mTab = findViewById(R.id.sobot_wo_pst_tab);
        mTab.setViewPager(viewPager);
        regReceiver();
    }

    private void regReceiver(){
        IntentFilter filter = new IntentFilter();

        if (unReadMsgReceiver == null){
            unReadMsgReceiver = new SobotUnReadMsgReceiver();
        }
        filter.addAction(ZhiChiConstant.sobot_unreadCountBrocast);
        registerReceiver(unReadMsgReceiver, filter);
    }

    @Override
    protected void onDestroy() {
        try {
            if (unReadMsgReceiver != null){
                unregisterReceiver(unReadMsgReceiver);
            }
        } catch (Exception e){
            e.printStackTrace();
        }

        super.onDestroy();
    }
}