package com.sobot.chat.widget.refresh;

import android.content.Context;
import android.graphics.PointF;
import android.util.DisplayMetrics;

import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.LinearSmoothScroller;
import androidx.recyclerview.widget.RecyclerView;

//调整滚动速度
public class SobotScrollLinearLayoutManager extends LinearLayoutManager {
    private final float MILLISECONDS_PER_INCH = 0.05f;//数值越大速度越慢 默认1f

    public SobotScrollLinearLayoutManager(Context context, int orientation, boolean reverseLayout) {
        super(context, orientation, reverseLayout);
    }

    @Override
    public void smoothScrollToPosition(RecyclerView recyclerView, RecyclerView.State state, int position) {
        LinearSmoothScroller linearSmoothScroller = new LinearSmoothScroller(recyclerView.getContext()) {

            @Override
            protected int getHorizontalSnapPreference() {
                return SNAP_TO_START;
            }
            @Override
            protected int getVerticalSnapPreference() {
                return SNAP_TO_START;  // 将子view与父view顶部对齐
            }
        };
        linearSmoothScroller.setTargetPosition(position);
        startSmoothScroll(linearSmoothScroller);
    }
}